<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" indent="yes" omit-xml-declaration="yes"/>
	<xsl:template match="/">
		<html>
			<xsl:variable name="export"><xsl:value-of select="results/export"/></xsl:variable>
			<xsl:if test="$export = 'false'">
				<head>
					<title>User Folder Permissions</title>
				</head>
				<body bgcolor="#CCCCCC">
					<center><b>User Folder Sizes</b></center>
					<br/>
					Parameters : <xsl:value-of select="results/params"/><br/>
					<table cellpadding="5">
						<tr>
							<td></td>
							<td><b>Username</b></td>
							<td><b>Password</b></td>
							<td><b>Enabled</b></td>
							<td><b>Folder</b></td>
							<td><b>Location</b></td>
							<td><b>Permissions</b></td>
						</tr>
						<xsl:for-each select="results/users/users_subitem">
							<tr>
								<td></td>
								<td nowrap="nowrap" valign="top"><xsl:value-of select="username"/></td>
								<td nowrap="nowrap" valign="top"><xsl:value-of select="password"/></td>
								<td nowrap="nowrap" valign="top" colspan="4"><xsl:value-of select="enabled"/></td>
							</tr>
							<xsl:for-each select="listing/listing_subitem">
								<tr>
									<td></td>
									<td></td>
									<td></td>
									<td nowrap="nowrap" valign="top"><xsl:value-of select="name"/></td>
									<td nowrap="nowrap" valign="top"><xsl:value-of select="url"/></td>
									<td nowrap="nowrap" valign="top"><xsl:value-of select="privs"/></td>
								</tr>
							</xsl:for-each>
							<tr>
								<td></td>
								<td colspan="4"><hr/></td>
							</tr>
						</xsl:for-each>
					</table>
				</body>
			</xsl:if>
			<xsl:if test="$export = 'true'">
				"User Folder Permissions"<br/>
				"<xsl:value-of select="results/params"/>"<br/>
				,"Username"
				,"Enabled"
				,"Folder"
				,"Location"
				,"Permissions"
				<br/>
				<xsl:for-each select="results/users/users_subitem">
					<xsl:for-each select="listing/listing_subitem">
						,"<xsl:value-of select="../../username"/>"
						,"<xsl:value-of select="../../enabled"/>"
						,"<xsl:value-of select="name"/>"
						,"<xsl:value-of select="url"/>"
						,"<xsl:value-of select="privs"/>"
						<br/>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:if>
		</html>
	</xsl:template>
</xsl:transform>