/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelSettings = {};
panelSettings.localization = {};
/****************************/

// Panel details
var panelName = "Settings";
panelSettings._panel = $("#pnl" + panelName);

// Localizations
panelSettings.localization = {
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelSettings.localization, localizations.panels[panelName]);

// Interface methods
panelSettings.init = function(){
	applyLocalizations(panelName, localizations.panels);
	window.dataBindEvents.push(panelSettings.bindData);
	panelSettings.bindEvents();
}

panelSettings.clearForm = function(panel)
{
	panel = panel || panelSettings._panel;
	panel.find("input, select, textarea").each(function(){
		if($(this).attr("type")=="checkbox")
		{
			if($(this).closest("td").is(".checkboxArea"))return;
			userManager.UI.checkUnchekInput($(this));
		}
		else
		{
			$(this).val("");
		}
	});
}

panelSettings.bindData = function(userInfo, jsonDeep, panel)
{
	var dataPanel = panel || panelSettings._panel;
	panelSettings.clearForm(dataPanel);

	if(panel)
	{
		panel.removeClass("inheritValSet");
	}

	if(userInfo.user)
	{
		userManager.data.bindValuesFromJson(dataPanel, userInfo.user, false, panel);
	}
	if(userInfo.user.user_bytes_received != undefined)
	{
		$("#user_bytes_received", panelSettings._panel).text(userManager.methods.round(parseInt(userInfo.user.user_bytes_received)/1024, 2)).attr("bytes", userInfo.user.user_bytes_received);
	}
	if(userInfo.user.user_bytes_sent != undefined)
	{
		$("#user_bytes_sent", panelSettings._panel).text(userManager.methods.round(parseInt(userInfo.user.user_bytes_sent)/1024, 2)).attr("bytes", userInfo.user.user_bytes_sent);
	}
	userManager.UI.panelsPostbindEvent(dataPanel, panel);
}

panelSettings.bindEvents = function()
{
	userManager.UI.togglePanels(panelSettings._panel);

	$(".checkboxArea>input[type='checkbox']", panelSettings._panel).change(function(){
		var curUserData = userManager.storage("currentUserInherited");
		if(!$(this).is(":checked"))
		{
			curUserData = {user: userManager.storage("currentUsersLowerLevelsData")};
			$(this).closest("fieldset").addClass("inheritSet");
		}
		else
			$(this).closest("fieldset").removeClass("inheritSet");
		if(!$(this).closest("fieldset").hasClass("notInheritable"))
			panelSettings.bindData(curUserData, false, $(this).closest("fieldset"));
	});

	$("#editCredits", panelSettings._panel).unbind().click(function(){
		var creditsData = $("#creditsData", panelSettings._panel);
		var upVal = creditsData.find("#user_bytes_received").text();
		var downVal = creditsData.find("#user_bytes_sent").text();
		jPrompt("Choose one :", "", "Stop Options", function(value){
			if(value)
			{
				function enterBytes(flag)
				{
					var type = flag ? "Uploaded " : "Downloaded ";
					var curVal = flag ? upVal : downVal;
					jPrompt("Please enter a Kilobytes amount (just a number, no label) :", curVal, type + "Bytes!", function(value){
						if(value)
						{
							value = parseInt(value);
							if(isNaN(value))value = 0;
							if(flag)
							{
								creditsData.find("#user_bytes_received").text(value).attr("bytes", value*1024);
							}
							else
							{
								creditsData.find("#user_bytes_sent").text(value).attr("bytes", value*1024);
							}
							panelSettings._panel.trigger("changed");
						}
					});
				}
				enterBytes(value == 0);
			}
		}, ["0|Edit Upload Bytes", "1|Edit Download Bytes"]);
		return false;
	});

	$("a.serverFilePickButton", panelSettings._panel).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel"), panelSettings._panel).val(selectedPath).trigger("change");
					panelSettings._panel.trigger("changed");
				}
			});
			return false;
		});
	});
}

panelSettings.generateXML = function()
{
	var xml = "";

	//General items
	panelSettings._panel.find("td.checkboxArea").not(".specialProperty").find("input:checked").each(function(){
		var formPanel = $(this).closest("td").next();
		xml += "\r\n" + userManager.data.buildXMLToSubmitForm(formPanel);
	});

	if($(".ratio_checkBox", panelSettings._panel).is(":checked"))
	{
		xml += "\r\n<user_bytes_received>"+$("#user_bytes_received", panelSettings._panel).attr("bytes")+"</user_bytes_received>";
		xml += "\r\n<user_bytes_sent>"+$("#user_bytes_sent", panelSettings._panel).attr("bytes")+"</user_bytes_sent>";
	}

	xml += "\r\n" + userManager.data.buildXMLToSubmitForm(panelSettings._panel.find("#CrushStaticVars"));

	return xml;
}